
// ********************************************************************
//
// Routine:     acstop.C
// Author:      T. Oest
//
// Description:  termination for ac routines
//
// Changes:
// 01 Aug 2000 (AG) added DQ_stop()
//
// ********************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "farm/farm.hh"

// prototypes
int gageStop();
int DQ_stop();

//*********************************************************************
// function
//*********************************************************************
extern "C" int
acstop_()
{
  ARTE_mark( "acstop_ 0", 0 );
  cout << "acstop_" << endl;

  //
  // gage termination
  //
  gageStop();

  //
  // DQ termination
  //
  DQ_stop();

  ARTE_mark( "acstop_ 1", 0 );
  return 0;
}
