
#include "arte/Chrono.hh"
#include "arte/ChronoManager.hh"

Chrono *cron_usevnt = 0;

//
// start timer
//
extern "C"
void uttime_start_()
{
  if( !cron_usevnt ){
    ChronoManager CM;
    cron_usevnt = CM.createChrono( "usevnt" );
  }
  cron_usevnt->start();
}

//
// stop timer
//
extern "C"
float uttime_stop_()
{
  cron_usevnt->stop();
  return cron_usevnt->lastTime();
}
