      REAL FUNCTION DGPTF( CHARGE )
************************************************************************
*                                                                      *
* DDDDDDDDD      GGGGGGGGGG   PPPPPPPPPPP   TTTTTTTTTTTT  FFFFFFFFFFFF *
* DDDDDDDDDD    GGGGGGGGGGGG  PPPPPPPPPPPP  TTTTTTTTTTTT  FFFFFFFFFFFF *
* DD       DD   GG        GG  PP        PP       TT       FF           *
* DD        DD  GG            PP        PP       TT       FF           *
* DD        DD  GG            PP        PP       TT       FF           *
* DD        DD  GG            PPPPPPPPPPPP       TT       FFFFFFFF     *
* DD        DD  GG     GGGGG  PPPPPPPPPPP        TT       FFFFFFFF     *
* DD        DD  GG     GGGGG  PP                 TT       FF           *
* DD        DD  GG        GG  PP                 TT       FF           *
* DD       DD   GG        GG  PP                 TT       FF           *
* DDDDDDDDDD    GGGGGGGGGGGG  PP                 TT       FF           *
* DDDDDDDDD      GGGGGGGGGG   PP                 TT       FF           *
*                                                                      *
************************************************************************
* written by I.Belyaev 18.09.97                                        *
* Description:                                                         *
* This function return  the probability distribution function for      *
* the charge                                                           *
*                                                                      * 
* Called from: DGPTO,DGPTQ                                             *
*                                                                      *
* Arguments:                                                           *
* name       in/out/update Argument description                        *
*                                                                      *
************************************************************************

      IMPLICIT NONE

      REAL     CHARGE , FUN
 

      IF( CHARGE .LE. 0.0 )THEN
       FUN = 0.0
      ELSE 
       FUN = 38.53*(CHARGE**0.6513)*EXP(-0.06433*CHARGE)
      ENDIF 
     
      DGPTF = FUN

      RETURN 
      END
