
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
// changes:
// 27 Oct 1999 (AG) use defines in DQ.h
// 19 Nov 1999 (AG) show up
// 15 Mar 2000 (NR) add tltarte/ prefix (tlt becomes part of ARTE)
//  6 Jul 2000 (AG) polished printout
//  
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "component.h"

// Arte inlcudes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_TLT.h"
#include "tltarte/tlt.hh"

//
// function code
//
int
DQ_TLT_rec_init()
{
  ARTE_mark( "DQ_TLT_rec_init 0", 0 ); 
  cout << "DQ_TLT_rec_init" << endl;
  tlt_init();
  ARTE_mark( "DQ_TLT_rec_init 1", 0 ); 
  return 0; // return error code (0 = okay)
}
