#include "arte/arte.hh"
#include "grover/grover.hh"

// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
//
//

int GroverFillFromRSEG(GroverParticleList* gpl)
{
  int errorflag = 0;
  for (ArteTable<RSEG>::iterator irseg = ArteTable<RSEG>::begin();
       irseg != ArteTable<RSEG>::end(); ++irseg) {
    if (((irseg->fit)==0)&&((irseg->zf)<=200.)) { // segment is in VDS
      //GroverParticle temp(irseg);
      gpl->push_back(GroverParticle(irseg));
    }
  }
  if (gpl->empty()) errorflag = -1;
  return errorflag;
}
