#include "arte/arte.hh"
#include "grover/grover.hh"

//
// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
//
//

int GroverFillFromRVER(GroverVertexList* list)
{
  // Fill a list of vertices from RVER 
  if (ArteTable<RVER>::size() > 0) {
    for (ArteTable<RVER>::iterator irver = ArteTable<RVER>::begin();
	 irver != ArteTable<RVER>::end(); ++irver) {
      GroverVertex vtx(irver);
      list->push_back(vtx);
    }
  }
  
  return (list->empty()) ? -1 : 0;
}
