*-- Author :    Hartwig Albrecht   22/11/95

      SUBROUTINE KAGTAB (ITAB)

************************************************************************
*
* Description: get link number of an Arte table from KUIP
*
* Called from: KA.... routines
*
* External references:
*
* Argument in/out description
*   ITAB   out    link number: ... JLINK(ITAB) ...; 0: error
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      INTEGER ITAB, UTTABNF, LENOCC
      CHARACTER*80 CTAB

#include "arte/Arte.ff"

      CTAB = ' '
      CALL KUGETC (CTAB, ITAB)
      IF (ITAB .EQ. 0)  THEN
        CALL MEERRC (75455,
     +    'specify an Arte table in the above command!')
        GO TO 90
      END IF

      ITAB = UTTABNF (CTAB)

      IF (ITAB .EQ. 0)  THEN
        CALL MEWARC (5612345,
     +    'Arte table ' // CTAB(1:LENOCC(CTAB)) // ' does not exist')
        GO TO 90
      END IF

      IF (JLINK(ITAB) .EQ. 0)  THEN
         CALL MEWARC (5612345,
     +    'Arte table ' // CTAB(1:LENOCC(CTAB)) // ' is empty')
         ITAB = 0
      END IF

 90   END

************************************************************************
* End of KAGTAB
************************************************************************
