*CMZ :  0.01/02 10/08/94  21.26.46  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  13.13.55  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/07/94
************************************************************************************
*
* L1JOBDI
* written by Dominik Ressing, 18/07/94 15.08.35
*
* This routines action:
* Delete a JOB: disconnect job ipoint from its queue
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* ipoint        in         pointer to job
*
************************************************************************************
c
      SUBROUTINE L1JOBDI(ipoint)
c
      IMPLICIT NONE
c
#include "l1si/l1jobdf.fi"
c
      INTEGER inext,iprev,ipoint
c
c     --- find next and previous jobs:
      iprev = L1JOBstore(ipoint+L1JOBprev)
      inext = L1JOBstore(ipoint)
c
c     --- job-queue header (this is invalid!)?
      IF ( iprev.le.0 ) THEN
         print *,'L1JOBDI ==> can not delete job-queue header !'
c
c     --- last job?
      ELSE IF ( inext.le.0 ) THEN
         L1JOBstore(iprev) = 0
      ELSE
         L1JOBstore(iprev)           = inext
         L1JOBstore(inext+L1JOBprev) = iprev
      END IF
c
      RETURN
c
      END
