*CMZ :  1.00/00 22/09/94  20.06.07  by  Fedor Ratnikov
*CMZ :  0.01/02 12/08/94  20.47.46  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  15.06.32  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1PREHA
* written by Dominik Ressing, 24/07/94 16.23.08
*
* This routines action:
* Performes hardware simulation of the pretriggers for the
* current BX L1PARcuBX
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iPre        in          number of pretrigger
* ierr        out         set to <>0 on error
*
************************************************************************
c
      SUBROUTINE L1PREHA(iPre,ierr)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER ierr,iPre,iPrPo,Num
#include "l1si/l1prcdf.ff"
c
      iPrPo = L1PCprep(iPre)                            ! pointer to proc definitions
      IF ( L1PCstor(iPrPo+L1PCtype).ne.L1PCtpre ) THEN  ! is this really a pretrigger?
         ierr = -1
         RETURN
      END IF
c
      Num = L1PCstor(iPrPo+L1PCnum)                     ! number as in l1simu.dat
      IF ( L1DEFpredef(L1PREkind,num).eq.L1PREelec ) THEN
c here is the ecal part missing
      ELSE IF ( L1DEFpredef(L1PREkind,num).eq.L1PREmuon ) THEN
c  here is the muon part missing
      END IF
c
c
      RETURN
c
      END
