*****************************************************
*     F.Ratnikov
*     GEANT interface routines for muarrange.C module
*****************************************************
      subroutine masetgeant (fIvo, fIn, fIdNew)
*     set new volume copy number
      implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcnum.fi"

      integer fIvo, fIn, fIdNew

      if (fIvo.gt.0)
     &     q(lq(lq(jvolum-fIvo)-fIn)+3) = fIdNew
      return
      end

      subroutine magetvolume (fName, fIdOld, fIvo, fIn)
* seach for volume with given copy number
      implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcnum.fi"

      integer fIdOld, fIvo, fIn
      character*4 fName
      integer ivo, iv, jvo, in, jin, nin, nr, ifound, iv0
      integer iname
      character*4 cname
      equivalence (iname,cname)

      ifound = 0
      fIvo = 0
      fIn = 0
      iv0 = 0

      do ivo = 1,nvolum
       iname = iq(jvolum+ivo)
       if (cname.eq.fName)  then
        iv0 = ivo
        goto 100
       endif
      enddo
 100  continue
      
      if (iv0.le.0)  then
       print *, 'magetvolume: volume not found ', fName
       return
      endif
      
      do ivo = 1,nvolum
       jvo = lq(jvolum-ivo)
       if (jvo.gt.0)  then
        nin = q(jvo+3)
        if (nin.gt.0)   then
         do in = 1, nin
          jin = lq(jvo-in)
          if (jin.gt.0)  then
           nr = q(jin+3)
           iv = q(jin+2)
           if (iv.eq.iv0.and.nr.eq.fIdOld) then
            fIvo = ivo
            fIn = in
            ifound = ifound + 1
           endif
          endif
         enddo
        endif
       endif
      enddo

      if (ifound.lt.1)
     &     print *, 'magetvolume: volume copy not found ', fName, fIdOld
      if (ifound.gt.1)
     &     print *, 'magetvolume: several volumes found ', 
     &     ifound, fName, fIdOld

      return
      end


