*
* B.Fominykh  2.09.99
*
* cross check of pad chamber hits
      SUBROUTINE MURPDTS
C-    ==================
*
      IMPLICIT NONE
      INTEGER IH,JH,IHB,JHB,IGD,JGD,IW,JW,IWB,JWB,IP,JP,IPB,JPB
      INTEGER NPD,NRPD,NPW,NRPW
      REAL XMD
*
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      NPD=0
      NRPD=0
      NRPW=0
      NPW=0
      IF(JTMP9.LE.0) GOTO 900
      IF(IQ(JTMP9+2).LT.1) GOTO 900
      DO IH=1,IQ(JTMP9+2) 
       JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
       IQ(JH+20)=1
      ENDDO
*
* loops over TMP9 hits
      DO 50 IH=1,IQ(JTMP9+2) 
       JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
       IF(IQ(JH+5).EQ.3.OR.IQ(JH+3).LE.2) GOTO 50
* hit GEDE element
       IHB=IQ(JH+1)
       JHB=JHITB+IQ(JHITB+1)*(IHB-1)+2
       IGD=IQ(JHB+JHITB_GEDE)
       JGD=JGEDE+IQ(JGEDE+1)*(IGD-1)+2
* x-coordinate of the chamber middle
       XMD=0.5*(Q(JGD+JGEDE_XMIN)+Q(JGD+JGEDE_XMAX))
*
* check pads
       IF(IQ(JH+5).EQ.2) THEN
        NPD=NPD+1
* look for the related wire
        DO 20 IW=1,IQ(JTMP9+2)
         JW=JTMP9+IQ(JTMP9+1)*(IW-1)+2
         IF(IQ(JW+5).EQ.1.AND.IQ(JW+3).GT.2) THEN
* wire GEDE element
          IWB=IQ(JW+1)
          JWB=JHITB+IQ(JHITB+1)*(IWB-1)+2
* check that the wire is on the same side
          IF(IQ(JWB+JHITB_GEDE).EQ.IGD) THEN
           IF((XMD-Q(JW+8))*(XMD-Q(JH+8)).GT.0.) THEN
            IQ(JW+20)=2
            GOTO 50
           ENDIF
          ENDIF
         ENDIF
 20     CONTINUE
* pad has no related wire
        IQ(JH+20)=0
        NRPD=NRPD+1       
        GOTO 50
       ENDIF
*
* check pad chamber wires
       IF(IQ(JH+5).EQ.1.AND.IQ(JH+3).GT.2) THEN
        NPW=NPW+1
        IF(IQ(JH+20).EQ.2) GOTO 50
* look for the related pad
        DO 40 IP=1,IQ(JTMP9+2)
         JP=JTMP9+IQ(JTMP9+1)*(IP-1)+2
         IF(IQ(JP+5).EQ.2) THEN
* pad GEDE element
          IPB=IQ(JP+1)
          JPB=JHITB+IQ(JHITB+1)*(IPB-1)+2
* check that the pad is on the same side
          IF(IQ(JPB+JHITB_GEDE).EQ.IGD) THEN
           IF((XMD-Q(JP+8))*(XMD-Q(JH+8)).GT.0.) GOTO 50
          ENDIF
         ENDIF
 40     CONTINUE
* wire has no related pad
        IQ(JH+20)=0
        NRPW=NRPW+1       
        GOTO 50
       ENDIF
 50   CONTINUE
*
 900  CONTINUE
      RETURN
      END
