*-- Author :    Rainer Mankel   14/05/96
*-- changed:    A. Spiridonov   20/10/99
*  parameter (y_marg=2.), flag TRIPLET_CUTY off     14/08/00 A. Spiridonov 
*
*#define TRIPLET_CUTY
*#define NEW_TRIPLETY
#define CONTY_LOCK
*#define DEBUG_TFCONTYN
*#define ANALYSE_CLUSTERY 
#define NEW_Y_MAXHIT 

      subroutine tfcontyn(dw,tabl,direction)

*     **** construct and propagate vertical seeds
      implicit none
**include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zplx.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
      integer dw,method,ihit,pl
      real x,rgxseg,y,y_marg,y_acs
#ifndef TRIPLET_CUTY
      parameter (y_marg=2.)
#else
      parameter (y_marg=10.)
#endif
      real dxmax,dzmin,txmax,dtxmax,dxclus,dtxclus,zref,dz1,tx1,dz2,
     +        tx2,sum_z,dx,dtx,tx_nsig,dtxres
      integer dom,win,ilay,iih,idh,hitb,cmp,isig,ind1,ind2,ind3,s1,
     +     s2,s3,t1,t2,tlast,ii,jj,kk,set0,trip0,clus0,
     +     ref,trip,clus,t,trip_found,clus_found,n_z,
     +     direction

      real rgzlay
      integer rgwidom,tabl,rgtabssw
      integer maxlay,maxhit
#ifndef NEW_Y_MAXHIT
      parameter (maxlay=6,maxhit=100)
#else
      parameter (maxlay=6,maxhit=300) 
#endif
      integer vlay(maxlay),vhit(maxhit)
      integer nlay,nhit
      integer seed,lay

      integer maxref
      parameter (maxref=1000)
      integer nref,vecref(maxref)
      integer maxhc
      parameter (maxhc=300)
      integer nhc,hit_hc(maxhc),indhc(maxhc),
     +     nhit_current,hc
      integer message_id_1, message_id_2 , message_id_3,
     +     message_id_4
      logical init

#ifdef NEW_TRIPLETY
      real xs1,xs2,xs3,zs1,zs2,zs3,zs1_2,zs2_2,zs3_2
      real sum_x,sum_xz,sum_z2,sum_xz2,det,idet,s_x0,s_tx
#endif

      data message_id_1 /1/,message_id_2 /2/,message_id_3 /3/,
     +     message_id_4 /4/
      data init /.false./

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      dxmax = 200.              ! maximum x difference for doublets
      dzmin = 0.1               ! minimum z difference for doublets
      txmax = 1.                ! maximum slope for doublets
      dtxmax = 0.20             ! maximum slope difference for triplets
      tx_nsig = 2.              !          ||   in sigmas
      dxclus = .60              ! maximum x  difference for cluster

      dtxclus = 0.10            ! maximum tx difference for cluster

      nset = nsetx              ! clear y area
      ntrip = ntripx            !
      nclus = nclusx            !

      set0= nsetx

      dom = rgwidom(dw)

      seed =  rgtabssw(dw,tabl,2)  ! get seeding set
**      print *,' tfcontyn: seed=',seed

      if (seed.eq.0) then
         print *,' tfcontyn: seed not found'
         go to 999
      endif
         
      call rgsdlay(seed,maxlay,vlay,nlay)
**      print *,' tfcontyn: rgsdlay returns nlay=',nlay

      if (nlay.lt.3) then
         print *,' tfcontyn: nlay only',nlay
         go to 999
      endif

      sum_z = 0.              ! calculate reference z
      n_z = 0
      do 60 ilay=1,nlay

**         print *,' tfcontyn:      ilay=',ilay,
**     +        ' lay=',vlay(ilay),' z=',rgzlay(vlay(ilay))
**         call rgdldmp(vlay(ilay))
         sum_z = sum_z + rgzlay(vlay(ilay))
         n_z = n_z + 1
 60   continue
      zref = sum_z / n_z

*     **** collect stereo hits
      do 90 ilay=1,nlay
         lay = vlay(ilay)
         if (lay.eq.0) go to 91
         nhit = 0
         call rghl(lay,maxhit,vhit,nhit)
*         call rgdldmp(lay)

         x = rgxseg(rgzlay(lay),rgwidom(dw)) ! approximate track x position

         do 40 ihit=1,nhit
            hitb = vhit(ihit)
#ifdef CONTY_LOCK
            if (segstor_zfpar) then
               if (phitb_rseg(hitb).gt.0) go to 40 ! used hit
            else
               if (phitb_rtra(hitb).gt.0) go to 40 ! used hit
            endif
#endif
            pl = ihitb_gede(hitb)
            cmp = igede_cmp(pl)
            
            if (nset.le.(maxset-2)) then
               if (cmp.eq.1.or.cmp.eq.3) then ! strip
                  y_acs = (x * fgede_rot(1,pl) - fhitb_x(hitb))
     +                 / fgede_rot(2,pl)
                  y = x * fgede_rot(2,pl) + y_acs * fgede_rot(5,pl)
#ifdef DEBUG_TFCONTYN   
                     print *,' () tfcontyn : ihit=',ihit,
     +                      ' zh ',fhitb_z(hitb),' x ',x,
     +                      ' y ',y,' ymin,max ',fgede_symn(pl),
     +                      fgede_symx(pl)

#endif
                  if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                 y.gt.(fgede_symx(pl)+y_marg)) go to 40
                  nset = nset + 1
                  x_set(nset) = (rgxseg(fhitb_z(hitb),rgwidom(dw))
     +                 * fgede_rot(1,pl) - fhitb_x(hitb))
     +                 / fgede_rot(2,pl)
                  z_set(nset) = fhitb_z(hitb)
                  hit_set(nset) = hitb
                  sig_set(nset) = 0
                  dl_set(nset) = lay
                  indset(nset) = nset

#ifdef DEBUG_TFCONTYN   
                     print *,' () tfcontyn : indset=',indset(nset),
     +                    ' hit=',hit_set(nset),
     +                    ' sig=',sig_set(nset),
     +                    ' z=',z_set(nset),
     +                    ' x=',x_set(nset)
#endif

               elseif (cmp.eq.2) then ! wirech
                  do 70 isig=-1,1,2
**                     y = (x * fgede_cos(pl) - fhitb_x(hitb)
**     +                    - isig * abs(fhitb_q(hitb)))
**     +                    / fgede_sin(pl)
                     y_acs = (x * cstot_plx(pl) - fhitb_x(hitb)
     +                    - isig * abs(fhitb_q(hitb)))
     +                    / sntot_plx(pl)
                     y = x * fgede_rot(2,pl) + y_acs * fgede_rot(5,pl)
#ifdef FULL
                     if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                    y.gt.(fgede_symx(pl)+y_marg)) then
                        if (isig*fhitb_q(hitb).gt.0.) then
                           print *,' tfcontyn: good stereo hit ',
     +                          hitb,' sig=',isig,
     +                          ' x=',x,' y_acs=',y_acs,
     +                          ' y=',y,
     +                          ' killed by margin in pl=',pl
                        else
                           print *,' tfcontyn: bad  stereo hit ',
     +                          hitb,' sig=',isig,
     +                          ' x=',x,' y_acs=',y_acs,
     +                          ' y=',y,
     +                          ' killed by margin in pl=',pl
                        endif
                     endif
#endif
                     if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                    y.gt.(fgede_symx(pl)+y_marg)) go to 70
                     nset = nset + 1
                     
**                     x_set(nset) = (rgxseg(fhitb_z(hitb),dom)
**     +                    * fgede_cos(pl) - fhitb_x(hitb)
**     +                    - isig * abs(fhitb_q(hitb)))
**     +                    / fgede_sin(pl)
                     x_set(nset) = (rgxseg(fhitb_z(hitb),dom)
     +                    * cstot_plx(pl) - fhitb_x(hitb)
     +                    - isig * abs(fhitb_q(hitb)))
     +                    / sntot_plx(pl)
                     z_set(nset) = fhitb_z(hitb)
                     hit_set(nset) = hitb
                     sig_set(nset) = isig
                     dl_set(nset) = lay
                     indset(nset) = nset
 70               continue
               else
                  print *,' () tfcontyn: invalid cmp=', cmp
                  print *,' dw,lay,pl,hitb=',
     +                 dw,lay,pl,hitb
               endif
            else
               call mepric(message_id_1,1,
     +              'tfcontyn: overflowing nset, hits skipped')
               go to 91
            endif
 40      continue               ! hits in layer
 41      continue
 90   continue                  ! layers
 91   continue

*     **** sort the hit set (increasing x)
      call sortzv(x_set,indset(set0+1),nset-set0,+1,0,1)

**      print *,' tfcontyn: number of sets found =',nset-set0

*     **** sample hit triplets
      trip0 = ntrip
      do 10 ind1=set0+1,nset-2  ! loop over base hit
         s1 = indset(ind1)
         do 20 ind2=ind1+1,nset-1 ! loop over second hit
            s2 = indset(ind2)
            if ((x_set(s2)-x_set(s1)).gt.dxmax) go to 21
            dz1 = z_set(s2) - z_set(s1)
            if (abs(dz1).lt.dzmin) go to 20
            tx1 = (x_set(s2)-x_set(s1)) / dz1
            if (abs(tx1).gt.txmax) go to 20
            do 30 ind3=ind2+1,nset ! loop over third hit
               s3 = indset(ind3)
               if ((x_set(s3)-x_set(s1)).gt.dxmax) go to 31
               dz2 = z_set(s3) - z_set(s1)
               if (abs(dz2).lt.dzmin) go to 30
               tx2 = (x_set(s3) - x_set(s1)) / dz2
               if (abs(tx2).gt.txmax) go to 30
               dtxres = 10. * tx_nsig * sqrt(
     +              (1./dz2 - 1./dz1)**2 * fhitb_r(hit_set(s1))**2
     +              + (1./dz1)**2 * (fhitb_r(hit_set(s2)))**2
     +              + (1./dz2)**2 * (fhitb_r(hit_set(s3)))**2 )

               if (abs(tx1-tx2).lt.dtxres) then ! triplet found
                  if (ntrip.lt.maxtrip) then
                     ntrip = ntrip + 1
                     zref_trip(ntrip) = zref
#ifndef NEW_TRIPLETY
                     tx_trip(ntrip) = 0.5 * (tx1 + tx2)
                     x_trip(ntrip) = x_set(s1)
     +                    + (zref-z_set(s1)) * tx_trip(ntrip)
#else
                     xs1 = x_set(s1) 
                     xs2 = x_set(s2) 
                     xs3 = x_set(s3) 
                     zs1 = z_set(s1) - zref
                     zs2 = z_set(s2) - zref
                     zs3 = z_set(s3) - zref
                     zs1_2 = zs1 * zs1
                     zs2_2 = zs2 * zs2
                     zs3_2 = zs3 * zs3
                     sum_z  = zs1 + zs2 + zs3
                     sum_z2 = zs1_2 + zs2_2 + zs3_2 
                     sum_x  = xs1 + xs2 + xs3
                     sum_xz = xs1*zs1 + xs2*zs2 + xs3*zs3
                     sum_xz2= xs1*zs1_2 + xs2*zs2_2 + xs3*zs3_2
                     det    = 3. * sum_z2 - sum_z * sum_z
                     s_x0   = sum_x * sum_z2 - sum_xz * sum_z
                     s_tx   = 3. * sum_xz - sum_x * sum_z
                     if(abs(det).lt.1.e-20) go to 30
                     idet = 1. / det
                     tx_trip(ntrip) = s_tx * idet
                     x_trip(ntrip) = s_x0 * idet 

*                     print *,' tfcontyn : ntrip ',ntrip,
*     +                      ' tx ',tx_trip(ntrip),' x ',x_trip(ntrip)
*     +                      ,' xs ',xs1,xs2,xs3,' zs ',zs1,zs2,zs3 
                     
#endif
                     s_trip(1,ntrip) = s1
                     s_trip(2,ntrip) = s2
                     s_trip(3,ntrip) = s3
                     clus_trip(ntrip) = 0
                     nx_trip(ntrip) = 0
                     indtrip(ntrip) = ntrip

#ifdef DEBUG_TFCONTYN  
                     print *,' tfcontyn : ntrip,ind'
     +                      ,ntrip,indtrip(ntrip)  
#endif

                  else
                     call mepric(message_id_2,1,
     +                    'tfcontyn: overflowing ntrip, sets skipped')
                     go to 11
                  endif
               endif
 30         continue            ! third hit
 31         continue
 20      continue               ! second hit
 21      continue
 10   continue                  ! base hit
 11   continue
      
**      print *,' tfcontyn: vertical triplets found: ',ntrip-ntripx

#ifdef DEBUG_TFCONTYN 
         do isig = trip0+1,ntrip
            t1 = indtrip(isig)
            s1=s_trip(1,t1)
            s2=s_trip(2,t1)
            s3=s_trip(3,t1)

                     print *,' tfcontyn : i,ntr',isig,t1, 
     +                    ' s =',hit_set(s1)*sig_set(s1)
     +                          ,hit_set(s2)*sig_set(s2)
     +                         ,hit_set(s3)*sig_set(s3), 
     +                    ' z=',zref_trip(t1), 
     +                    ' x=',x_trip(t1),
     +                    'tx=',tx_trip(t1) 
**     +                    ' x=',(x_trip(isig) + tx_trip(isig)
**     +                    * (zref_trip(isig) - 100.)) 

         end do
#endif

*     **** search triplet clusters
      call sortzv(tx_trip,indtrip(trip0+1),ntrip-trip0,+1,0,1)
     +                          ! sort tx

      clus0 = nclus
      do 50 ind1=trip0+1,ntrip  ! loop over first triplet
         t1 = indtrip(ind1)
         tlast = t1
         if (clus_trip(t1).gt.0) go to 50
         if (nclus.lt.maxclus) then
            nclus = nclus + 1   ! create cluster with this hit
            mult_clus(nclus) = 1
            trip1_clus(nclus) = t1
**               indclus(nclus) = nclus
         else
            call mepric(message_id_3,1,
     +           'tfcontyn: overflowing nclus, triplets skipped')
            go to 51
         endif
         clus_trip(t1) = nclus
         do ind2=ind1+1,ntrip   ! loop over following triplets
            t2 = indtrip(ind2)
            if ((tx_trip(t2)-tx_trip(t1)).gt.dtxclus) go to 50
            if (abs(x_trip(t2)-x_trip(t1)).lt.dxclus) then
               clus_trip(t2) = nclus ! add to same cluster
               mult_clus(nclus) = mult_clus(nclus) + 1
               if (tlast.gt.0) nx_trip(tlast) = t2
               tlast = t2
            endif
         enddo
 50   continue
 51   continue

#ifdef CLUSTERY_ANALYSIS
**      print *,' tfcontyn: analyze clusters ', clus0+1,' to ',nclus
      do clus=clus0+1,nclus     ! cluster analysis
         nhc = 0
         do 80 jj=1,99          ! locate triplets in cluster
            if (jj.eq.1) then
               t = trip1_clus(clus)
            else
               t = nx_trip(t)
            endif
            if (t.le.0) go to 81
            if (nhc.lt.(maxhc-3)) then
               nhc = nhc + 1
               hit_hc(nhc) = hit_set(s_trip(1,t))
               indhc(nhc) = nhc
               nhc = nhc + 1
               hit_hc(nhc) = hit_set(s_trip(2,t))
               indhc(nhc) = nhc
               nhc = nhc + 1
               hit_hc(nhc) = hit_set(s_trip(3,t))
               indhc(nhc) = nhc
            else
               call mepric(message_id_4,1,
     +              'tfcontyn: overflowing nhc, clusters skipped')
               go to 81
            endif
 80      continue
 81      continue
      enddo
#endif

      if (diag_level.ge.5) then
         print *,' tfcontyn: vertical sets=', nset-nsetx,
     +        '  triplets=', ntrip-ntripx,
     +        '  clusters=', nclus-nclusx
      endif

**      print *,' tfcontyn: call tfpropcy for cluster range ',
**     +     nclusx+1,nclus,' dir=',direction

      call tfpropcyn(nclusx+1,nclus,direction) ! propagate clusters

 999  end
