*-- Author :    Rainer Mankel   15/01/95

      subroutine tftlin(ndim, x_in, dz, x_out, f)

*     **** transport for straight lines
      implicit none
      integer i, j, ndim
      double precision x_in(5), x_out(5)
      double precision dz
      double precision f(5,5)

      if (ndim.ne.5) then
       print *,' () tftlin : ndim=', ndim
      endif

      x_out(1) = x_in(1) + dz * x_in(3)
      x_out(2) = x_in(2) + dz * x_in(4)
      x_out(3) = x_in(3)
      x_out(4) = x_in(4)
      x_out(5) = x_in(5)

      do 10 i=1,5
       do 10 j=1,5
        if (i.eq.j) then
         f(i,j) = 1.d0
        elseif ((i.eq.1.and.j.eq.3).or.(i.eq.2.and.j.eq.4)) then
         f(i,j) = dz
        else
         f(i,j) = 0.d0
        endif
 10   continue
      end




