*-- Author :    Hartwig Albrecht   17/02/95

      SUBROUTINE IOUNIT (CSYM, LUN)

************************************************************************
*
* Description: Get logical unit number LUN from file name CSYM
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   CSYM   in     file name
*   LUN    out    logical unit number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      CHARACTER *(*) CSYM, CSTR*80
      INTEGER LUN

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      IF (CSYM .EQ. ' ')  GO TO 20
      DO 10 LUN = 1, 99
        CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CSTR)
 10   IF (CSTR .EQ. CSYM)  GO TO 30
 20   LUN = 0

 30   END

************************************************************************
* End of IOUNIT
************************************************************************
