
/******************************************************************* 
 *
 * D. Samtleben 10 Aug 1999
 * A. Gellrich
 *
 * Declaration of Histograms and Initialization
 *
 * hints:
 *        components: COMP_SVD
 *                    COMP_ITR
 *                    COMP_HIPT
 *                    COMP_OTR
 *                    COMP_RICH
 *                    COMP_TRD
 *                    COMP_ECAL
 *                    COMP_MUON
 *                    COMP_FLT
 *                    COMP_SLT
 *                    COMP_TLT
 *                    COMP_FARM
 *
 *         levels:    LVL_RAW
 *                    LVL_HIT
 *                    LVL_REC
 *
 * changes:
 * 22 Oct 1999 (AG) code polishing
 * 27 Oct 1999 (AG) use defines from DQ.h
 *  1 Nov 1999 (AG) get rid of dq_hid.h
 * 19 Nov 1999 (AG) show up
 *
 *******************************************************************/ 

/* standard includes */
#include <stdlib.h>
#include <stdio.h>

/* ONLINE includes */
#include "rhp.h"

/* Arte includes */
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

/*               */
/* function code */
/*               */
int
DQ_MUON_raw_init()
{
  printf( "DQ_MUON_raw_init()\n" );
    
  /* book Bad FED histogram */
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_RAW,1),"MUON: Bad FEDs",5,-0.5,4.5 );

  return 0; /* return error code (0 = okay) */
}


