*CMZ :          16/03/96  09.12.53  by  Antonio Zoccoli
*CMZ :  2.01/02 22/01/96  16.42.22  by  Hartwig Albrecht
*-- Author : Lund
C*********************************************************************

      SUBROUTINE LUERRM(MERR,CHMESS)

C...Purpose: to inform user of errors in program execution.

CHA modified by H.A. in order to use the Arte error message package.

      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      SAVE /LUJETS/,/LUDAT1/
      CHARACTER CHMESS*(*)
      DIMENSION MERR(*)

#include "arte/Arte.fi"
#include "arte/Arte.ff"
C...Write first few warnings, then be silent.
      IF(MERR(1).LE.10) THEN
        MSTU(27)=MSTU(27)+1
        MSTU(28)=MERR(1)
        CALL MEMESC (MERR, MSTU(26), ILARGEST, CHMESS)
CHA        IF(MSTU(25).EQ.1.AND.MSTU(27).LE.MSTU(26)) WRITE(MSTU(11),5000)
CHA     &  MERR,MSTU(31),CHMESS

C...Write first few errors, then be silent or stop program.
      ELSEIF(MERR(1).LE.20) THEN
        MSTU(23)=MSTU(23)+1
        MSTU(24)=MERR(1)-10
CHA        IF(MSTU(21).GE.1.AND.MSTU(23).LE.MSTU(22)) WRITE(MSTU(11),5100)
CHA     &  MERR-10,MSTU(31),CHMESS
CHA        IF(MSTU(21).GE.2.AND.MSTU(23).GT.MSTU(22)) THEN
CHA          WRITE(MSTU(11),5100) MERR-10,MSTU(31),CHMESS
CHA          WRITE(MSTU(11),5200)
CHA          STOP
        IF (MSTU(21) .LE. 1)  THEN
          CALL MEMESC (MERR, MSTU(22), ILARGEST, CHMESS)
        ELSE
          IF(MERR(1).NE.17) CALL LULIST(2)
          CALL MEMESC (MERR, MSTU(22), MSTU(22), CHMESS)
        ENDIF

C...Stop program in case of irreparable error.
      ELSE
        CALL MEERRC (MERR, CHMESS)
CHA        WRITE(MSTU(11),5300) MERR-20,MSTU(31),CHMESS
CHA        STOP
      ENDIF

C...Formats for output.
C 5000 FORMAT(/5X,'Advisory warning type',I2,' given after',I6,
C     &' LUEXEC calls:'/5X,A)
C 5100 FORMAT(/5X,'Error type',I2,' has occured after',I6,
C     &' LUEXEC calls:'/5X,A)
C 5200 FORMAT(5X,'Execution will be stopped after listing of last ',
C     &'event!')
C 5300 FORMAT(/5X,'Fatal error type',I2,' has occured after',I6,
C     &' LUEXEC calls:'/5X,A/5X,'Execution will now be stopped!')

      RETURN
      END
