*-- Author :    Thomas Lohse   March 8, 1999

      SUBROUTINE KAUPSI

************************************************************************
*
* Description: MODE/UPSILON command; defines mode and parameters for 
*                           simulation of direct Upsilon production 
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "pyth/PYSUBS.fi"
#include "arte/luopts.fi"

      INTEGER L, mes_id_1
      CHARACTER*12 CH

      save mes_id_1


      call KUGETC(CH, L)
      if (CH(1:2).eq.'PT') then
        modeY = 1
      elseif (CH(1:2).eq.'RE') then
        modeY = 2
      else
        call MEERRC(mes_id_1, 'MODE/UPSILON: generator mode unknown')
        modeY = 2
      endif
      if (modeY.eq.1) then
        call KUGETR(pt0Y)
        CKIN(5) = pt0Y
      else
        pt0Y = CKIN(5)
      endif


 90   END

************************************************************************
* End of KAUPSI
************************************************************************
