// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 


#ifndef RANGER_XPRO_HH
#define RANGER_XPRO_HH

#include <vector.h>
#include <set.h>

class rangerNavItem;
class rangerXWin;

class rangerXPro {

public:
  rangerXPro(){};
  ~rangerXPro(){};

private:
  int ft;
  set<rangerNavItem*> navSet;
  vector<rangerXWin*> xws;
  double qptEst;
};
#endif
