*CMZ :  4.04/01 13/09/96  15.34.10  by  Rainer Mankel
*-- Author :    Rainer Mankel   13/09/96

      subroutine tfp2qpt(x,c,xout,cout)

*     **** translate (tx,ty,Q/p) -> (tx,ty,Q/pt)
      implicit none
      double precision x(5)       ! track parameter (input)
      double precision c(5,5)     ! cov track parameter (input)
      double precision xout(5)    ! track parameter (input)
      double precision cout(5,5)  ! cov track parameter (input)

*     **** input & output may be the same arrays

      double precision hc, ftx, ftxy, d_tx, d_ty, d_q, ctxtx, ctyty,
     +       cqq, ctxty, ctxq, ctyq
      integer i, j

      ftx = dsqrt(1.d0 + x(3)**2)
      ftxy = dsqrt(1.d0 + x(3)**2 + x(4)**2)
      d_tx = -x(5) * x(3) * x(4)**2 / (ftxy * ftx**3)
      d_ty =  x(5) * x(4) / (ftxy * ftx)
      d_q  =  ftxy / ftx

      xout(1) = x(1)
      xout(2) = x(2)
      xout(3) = x(3)
      xout(4) = x(4)
      xout(5) = d_q * x(5)

      do i=1,4
         do j=1,4
            cout(i,j) = c(i,j)
         enddo
      enddo

      cout(1,5) = d_q * c(1,5) + d_tx * c(1,3) + d_ty * c(1,4)
      cout(2,5) = d_q * c(2,5) + d_tx * c(2,3) + d_ty * c(2,4)

      ctxtx = c(3,3)
      ctyty = c(4,4)
      cqq   = c(5,5)
      ctxty = c(3,4)
      ctxq  = c(3,5)
      ctyq  = c(4,5)


      cout(3,5) = d_tx * ctxtx + d_ty * ctxty + d_q * ctxq
      cout(4,5) = d_tx * ctxty + d_ty * ctyty + d_q * ctyq
      cout(5,5) = d_tx**2 * ctxtx + d_ty**2 * ctyty
     +           + d_q**2 * cqq
     +           + 2.d0 * (d_tx * d_ty * ctxty
     +                   + d_tx * d_q  * ctxq
     +                   + d_ty * d_q  * ctyq )

      do i=1,4
         cout(5,i) = cout(i,5)
      enddo

      end

