
// *****************************************************************************
//
// source:    rcClassVZERO2.C
//
// type:      source code
//
// created:   19 Jul 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassVZERO2
//
// called by: rcClassify
//
// purpose:   class events with V0 candidate
//
// hints:
//
// changes:
// 19 Jul 2000 (AG) creation
// 21 Jul 2000 (AG) fix bug
// 25 Jul 2000 (AG) added rcSelectVZERO() and rcSelectVZERO2()
// 26 Jul 2000 (AG) use separate function for VZERO2
// 27 Jul 2000 (AG) uncommented rcSelectVZERO2()
// 06 Aug 2000 (AG) new class 0x10 (B)
//
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// prototypes
int rcSelectVZERO2();

//
// function code
//
int
rcClassVZERO2()
{
  ARTE_mark( "rcClassVZERO2 0", 0 );

  int rc = 0;
  rc = rcSelectVZERO2(); // bit 0x1:K0s 0x2:K892 0x4:Phi 0x8:D0 0x10:B

  ARTE_mark( "rcClassVZERO2 1", 0 );
  return rc;
}
