*
* B.Fominykh  18.06.99
* the program of the MUREC-B package
* preliminary version
* fills the muon likelyhoods in the RTRA table
* is called from .....
*
      SUBROUTINE RCMUID
*     =================
      IMPLICIT NONE
*
#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "auto/RTRA.fi"

      INTEGER IRT,JRT,ISG,JSG,CMP,JAUX,NHT,NH

*      integer matrix_pack(5,5) ! (copied from R. M.)
*      data matrix_pack
*     +     / 1,  2,  4,  7, 11,
*     +       2,  3,  5,  8, 12,
*     +       4,  5,  6,  9, 13,
*     +       7,  8,  9, 10, 14,
*     +      11, 12, 13, 14, 15 /
*      save matrix_pack

#include "arte/Arte.ff"
#include "auto/RSEG.ff"
#include "auto/RTRA.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********

* RTRA check-point
      IF(JRTRA.LE.0)       GOTO 999
      IF(IQ(JRTRA+1).LE.0) GOTO 999
      IF(IQ(JRTRA+2).LE.0) GOTO 999
* RSEG check-point
      IF(JRSEG.LE.0)       GOTO 999
      IF(IQ(JRSEG+1).LE.0) GOTO 999
      IF(IQ(JRSEG+2).LE.0) GOTO 999

* loops over RTRA table
      DO 100 IRT=1,IQ(JRTRA+2)
        JRT=JRTRA+IQ(JRTRA+1)*(IRT-1)+2
*
* muon identification flag
        IQ(JRT+JRTRA_FLM)=0 
* number of muon hits
#ifdef MU_ORIGINAL
        IQ(JRT+JRTRA_HMU)=0 
#endif
* likelyhood of muon hypothesis
        Q(JRT+JRTRA_LMMU)=0. 
* likelyhood of hadron hypothesis
        Q(JRT+JRTRA_LMH)=0. 
*
* check the related muon segment
        JAUX=PRTRA_RSEG(IRT)
#ifdef MU_ORIGINAL
  7     IF(JAUX.LE.0) RETURN
#else
  7     IF(JAUX.LE.0) GO TO  100
#endif
        ISG=MRTRA_RSEG(JAUX)
        IF(ISG.GT.0) THEN
          JSG=JRSEG+IQ(JRSEG+1)*(ISG-1)+2
          CMP=IQ(JSG+JRSEG_CMP)
          IF(CMP.EQ.rsegc_muon) THEN
            IQ(JRT+JRTRA_FLM)=1 
            Q(JRT+JRTRA_LMMU)=1. 
            GOTO 10
          ENDIF
        ENDIF
        JAUX=XRTRA_RSEG(JAUX)
        GOTO 7

* calculate the number of linked muon hits
#ifdef MU_ORIGINAL
 10     NHT=0
        JAUX=PRSEG_HITB(ISG)
 17     IF(JAUX.LE.0) GOTO 20
        NH=MRSEG_HITB(JAUX)
        IF(NH.GT.0) NHT=NHT+1
        JAUX=XRSEG_HITB(JAUX)
        GOTO 17
 20     IQ(JRT+JRTRA_HMU)=NHT
#else
 10     continue
#endif

 100  CONTINUE
*
 999  CONTINUE
      RETURN
      END









